--[[Keys = {
    ["ESC"] = 322, ["F1"] = 288, ["F2"] = 289, ["F3"] = 170, ["F5"] = 166, ["F6"] = 167, ["F7"] = 168, ["F8"] = 169, ["F9"] = 56, ["F10"] = 57, 
    ["~"] = 243, ["1"] = 157, ["2"] = 158, ["3"] = 160, ["4"] = 164, ["5"] = 165, ["6"] = 159, ["7"] = 161, ["8"] = 162, ["9"] = 163, ["-"] = 84, ["="] = 83, ["BACKSPACE"] = 177, 
    ["TAB"] = 37, ["Q"] = 44, ["W"] = 32, ["E"] = 38, ["R"] = 45, ["T"] = 245, ["Y"] = 246, ["U"] = 303, ["P"] = 199, ["["] = 39, ["]"] = 40, ["ENTER"] = 18,
    ["CAPS"] = 137, ["A"] = 34, ["S"] = 8, ["D"] = 9, ["F"] = 23, ["G"] = 47, ["H"] = 74, ["K"] = 311, ["L"] = 182,
    ["LEFTSHIFT"] = 21, ["Z"] = 20, ["X"] = 73, ["C"] = 26, ["V"] = 0, ["B"] = 29, ["N"] = 249, ["M"] = 244, [","] = 82, ["."] = 81,
    ["LEFTCTRL"] = 36, ["LEFTALT"] = 19, ["SPACE"] = 22, ["RIGHTCTRL"] = 70, 
    ["HOME"] = 213, ["PAGEUP"] = 10, ["PAGEDOWN"] = 11, ["DELETE"] = 178,
    ["LEFT"] = 174, ["RIGHT"] = 175, ["TOP"] = 27, ["DOWN"] = 173,
    ["NENTER"] = 201, ["N4"] = 108, ["N5"] = 60, ["N6"] = 107, ["N+"] = 96, ["N-"] = 97, ["N7"] = 117, ["N8"] = 61, ["N9"] = 118
}--]]

local invmenu = {
	opened = false,
	title = "Inventaire",
	currentmenu = "main",
	lastmenu = nil,
	currentpos = nil,
	selectedbutton = 0,
	marker = { r = 0, g = 155, b = 255, a = 200, type = 1 },
	menu = {
		x = 0.1,
		y = 0.32,
		width = 0.2,
		height = 0.04,
		buttons = 9,
		from = 1,
		to = 9,
		scale = 0.4,
		font = 0,
		["main"] = { 
			title = "", 
			name = "main",
			buttons = {
				
			}
		},
		["itemmenu"] = { 
			title = "", 
			name = "itemmenu",
			buttons = { 
				{name = "Utiliser", description = ''},
				{name = "Donner", description = ''},
				{name = "Supprimer", description = ''},
			}
		},
	}
}

function drawTxt(text,font,centre,x,y,scale,r,g,b,a)
	SetTextFont(font)
	SetTextProportional(0)
	SetTextScale(scale, scale)
	SetTextColour(r, g, b, a)
	SetTextDropShadow(0, 0, 0, 0,255)
	SetTextEdge(1, 0, 0, 0, 255)
	SetTextDropShadow()
	SetTextOutline()
	SetTextCentre(centre)
	SetTextEntry("STRING")
	AddTextComponentString(text)
	DrawText(x , y)	
end

local function LocalPed()
return GetPlayerPed(-1)
end

inmenuinv = 0

function CloseCreatorinvmenu()
	Citizen.CreateThread(function()
		invmenu.opened = false
		invmenu.menu.from = 1
		invmenu.menu.to = 10
		inmenuinv = 0
	end)
	Citizen.CreateThread(function()
	end)
end

function drawMenuButton(button,x,y,selected)
	local menu = invmenu.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(menu.scale, menu.scale)
	if selected then
		SetTextColour(0, 0, 0, 255)
	else
		SetTextColour(255, 255, 255, 255)
	end
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(button.name)
	if selected then
		DrawRect(x,y,menu.width,menu.height,255,255,255,255)
	else
		DrawRect(x,y,menu.width,menu.height,0,0,0,150)
	end
	DrawText(x - menu.width/2 + 0.005, y - menu.height/2 + 0.0028)	
end

function drawMenuInfo(text)
	local menu = invmenu.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(0.45, 0.45)
	SetTextColour(255, 255, 255, 255)
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(text)
	DrawRect(0.675, 0.95,0.65,0.050,0,0,0,150)
	DrawText(0.365, 0.934)	
end

function drawMenuRight(txt,x,y,selected)
	local menu = invmenu.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(menu.scale, menu.scale)
	SetTextRightJustify(1)
	if selected then
		SetTextColour(0, 0, 0, 255)
	else
		SetTextColour(255, 255, 255, 255)
	end
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(txt)
	DrawText(x + menu.width/2 - 0.03, y - menu.height/2 + 0.0028)	
end

function drawMenuTitleInvmen(txt,x,y)
local menu = invmenu.menu
	SetTextFont(2)
	SetTextProportional(0)
	SetTextScale(0.5, 0.5)
	SetTextColour(255, 255, 255, 255)
	SetTextEntry("STRING")
	AddTextComponentString(txt)
	DrawRect(x,y,menu.width,menu.height, 46, 83, 42, 150)
	DrawText(x - menu.width/2 + 0.005, y - menu.height/2 + 0.0028)
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function Notif(text)
	SetNotificationTextEntry("STRING")
	AddTextComponentString(text)
	DrawNotification(false, false)
end

local backlock = false
Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)
		if IsControlJustPressed(1,170) then
		  if IsPedInAnyVehicle(LocalPed(), true) == false then
			if invmenu.opened then
				CloseCreatorinvmenu()
				inmenuinv = 0
			else
				TriggerServerEvent('MyInv')	
				freezetargetCiv = totarget
				inmenuinv = 1
			end
		  else
		    Notif("~r~Vous ne pouvez pas ouvrir l'inventaire dans un véhicule")
	      end
		elseif IsControlJustPressed(1,166) or IsControlJustPressed(1,289) and invmenu.opened then
			CloseCreatorinvmenu()
			inmenuinv = 0
		end
		if invmenu.opened then
			local ped = LocalPed()
			local menu = invmenu.menu[invmenu.currentmenu]
			drawTxt(invmenu.title,1,1,invmenu.menu.x,invmenu.menu.y,1.0, 255,255,255,255)
			drawMenuTitleInvmen(menu.title, invmenu.menu.x,invmenu.menu.y + 0.08)
			drawTxt(invmenu.selectedbutton.."/"..tablelength(menu.buttons),0,0,invmenu.menu.x + invmenu.menu.width/2 - 0.0385,invmenu.menu.y + 0.067,0.4, 255,255,255,255)
			local y = invmenu.menu.y + 0.12
			buttoncount = tablelength(menu.buttons)
			local selected = false
			
			for i,button in pairs(menu.buttons) do
				if i >= invmenu.menu.from and i <= invmenu.menu.to then
					
					if i == invmenu.selectedbutton then
						selected = true
					else
						selected = false
					end
					drawMenuButton(button,invmenu.menu.x,y,selected)
					y = y + 0.04
					if selected and IsControlJustPressed(1,201) then
						ButtonSelectedinvmenu(button)
					end
				end
			end	
		end
		if invmenu.opened then
			if IsControlJustPressed(1,202) then
				Backinvmenu()
			end
			if IsControlJustReleased(1,202) then
				backlock = false
			end
			if IsControlJustPressed(1,188) then
				if invmenu.selectedbutton > 1 then
					invmenu.selectedbutton = invmenu.selectedbutton -1
					if buttoncount > 10 and invmenu.selectedbutton < invmenu.menu.from then
						invmenu.menu.from = invmenu.menu.from -1
						invmenu.menu.to = invmenu.menu.to - 1
					end
				end
			end
			if IsControlJustPressed(1,187)then
				if invmenu.selectedbutton < buttoncount then
					invmenu.selectedbutton = invmenu.selectedbutton +1
					if buttoncount > 10 and invmenu.selectedbutton > invmenu.menu.to then
						invmenu.menu.to = invmenu.menu.to + 1
						invmenu.menu.from = invmenu.menu.from + 1
					end
				end	
			end
		end
	end
end)
				
function ButtonSelectedinvmenu(button)
	local ped = GetPlayerPed(-1)
	local this = invmenu.currentmenu
	local btn = button.name

	callx, cally, callz = table.unpack(GetEntityCoords(GetPlayerPed(-1) , true))
	if this == "main" then
			useitem = button.use
			itemref = button.ref
			itemid = button.id
			nameofitem = button.textsing
			actualnumber = button.itemnumber
			invmenu.menu["itemmenu"].title = nameofitem
			OpenMenuinvmenu('itemmenu')
	elseif this == "itemmenu" then
		if btn == "Utiliser" then
			if (itemref ~= nil) then
				--Notif("Cet objet n'est pas utilisable")
				--UseEffectItem(itemref, 120000) -- 1 MINUTE
				Notif("Bientôt ..")
			end
		elseif btn =="Donner" then
		    if (itemref == "gps") and (actualnumber == 1) then
			    gpsacitve = 0
			end
			
			targetid = totarget
			if(targetid == nil) then
				TriggerServerEvent('inv:askGetItem',targetid,itemid,nameofitem)
			else
				Notif("Aucun joueur à proximité")
			end
			
			actualnumber = actualnumber -1
			if actualnumber <= 0 then
				CloseCreatorinvmenu()
			end

		elseif btn =="Supprimer" then
		    if (itemref == "gps") and (actualnumber == 1) then
			    gpsacitve = 0
			end
			TriggerServerEvent('InvDelete',itemid,nameofitem)
			actualnumber = actualnumber -1
			if actualnumber <= 0 then
				CloseCreatorinvmenu()
			end
			
		end
	end
end

function OpenMenuinvmenu(menu)
	invmenu.lastmenu = invmenu.currentmenu
	if menu == "itemmenu" then
		invmenu.lastmenu = "main"
	end
	invmenu.menu.from = 1
	invmenu.menu.to = 10
	invmenu.selectedbutton = 0
	invmenu.currentmenu = menu	
end


function Backinvmenu()
	if backlock then
		return
	end
	backlock = true
	if invmenu.currentmenu == "main" then
		CloseCreatorinvmenu()
	end
	if invmenu.currentmenu == "itemmenu" then
		invmenu.opened = false
		invmenu.menu.from = 1
		invmenu.menu.to = 10
		TriggerServerEvent('MyInv')	
	else
		OpenMenuinvmenu(invmenu.lastmenu)
	end
end

inputquantiteitem = 0

Citizen.CreateThread(function()
	while true do
		Wait(0)
		if inputquantiteitem == 1 then
			if UpdateOnscreenKeyboard() == 3 then
				inputquantiteitem = 0
			elseif UpdateOnscreenKeyboard() == 1 then
				inputmotifclient = GetOnscreenKeyboardResult()
					if string.len(inputmotifclient) > 0 then
						ResultMotifAdd = tonumber(inputmotifclient)
						if(ResultMotifAdd ~= nil) then
							if ResultMotifAdd > 0 then
								Notif("La quantité : ~g~"..tostring(ResultMotifAdd).." ~w~est ~g~valide")
								inputquantiteitem = 2
							elseif ResultMotifAdd > 30 then
								Notif("La quantité est trop ~r~élevée")
								inputquantiteitem = 0
							else
								Notif("La quantité n'est pas ~r~valide")
								inputquantiteitem = 0
							end
						else
							Notif("La quantité n'est pas ~r~valide")
							inputquantiteitem = 0
						end
					else
						inputquantiteitem = 0
					end

			elseif UpdateOnscreenKeyboard() == 2 then
				inputquantiteitem = 0
			end
		end
		if inputquantiteitem == 2 then
			TriggerServerEvent('inv:GetItem', totarget, itemIdAskGive, ResultMotifAdd, itemNameAskGive)
			inputquantiteitem = 0
		end
	end
end)

RegisterNetEvent('MyInvClient')
AddEventHandler('MyInvClient', function(playerinventory,iteminfo,playername)
	inmenuinv = 1
	iteminuse = 0
	local insrt = table.insert
	invmenu.menu["main"].title = playername
	invmenu.menu["main"].buttons = {}
	counttable = tablelength(playerinventory)
	countbutton = 0
	i = 1
	
	while countbutton ~= counttable do
		item = playerinventory[i]['quantity']
		item_id = playerinventory[i]['item_id']
		if item ~= null then			
			if item > 1 then
				nametext = iteminfo[tonumber(item_id)]['name_pluriel']
			else
				nametext = iteminfo[tonumber(item_id)]['name_singulier']
			end
			finaltext = item.." "..nametext
			refname = iteminfo[tonumber(item_id)]['item_price_name']
			fct = iteminfo[tonumber(item_id)]['function_use_item']
			reftext = iteminfo[tonumber(item_id)]['name_singulier']
			insrt(invmenu.menu["main"].buttons, {name = finaltext, description = "", ref = refname, itemnumber = item,textsing = reftext, use = fct, id = item_id})		
			countbutton = countbutton + 1
		end
		i = i + 1
	end

	invmenu.currentmenu = "main"
	invmenu.opened = true
	invmenu.selectedbutton = 0
end)

--NOTIFICATION 

RegisterNetEvent('inv:askItemMessage')
AddEventHandler('inv:askItemMessage', function(itemId, nameItem, sourceName)
	Notif("~b~"..sourceName.."~w~souhaite vous donner l'item ~g~"..nameItem)
	Notif("Appuyez sur ~b~Y ~w~ pour accepter ou ~r~X~w~pour refuser")
	itemNameAskGive = nameItem
	sourceNameAskGive = sourceName
	itemIdAskGive = itemId
	waitAskItem = true
end)

RegisterNetEvent('inv:setItemMessage')
AddEventHandler('inv:setItemMessage', function(nameItem, sourceName)
	Notif("Vous avez donné l'item ~g~"..nameItem.."~w~ à ~b~"..sourceName)
end)

RegisterNetEvent('Deletesource')
AddEventHandler('Deletesource', function(item)
	Notif("Vous avez supprimé l'item ~g~"..item)
end)

--INVENTAIRE
waitAskItem = false
Citizen.CreateThread(function()
	while true do
	Citizen.Wait(0)
        if waitAskItem == 1 then
			if IsControlJustPressed(1,246) then
				DisplayOnscreenKeyboard(true, "FMMC_KEY_TIP8", "", "", "", "", "", 120)
				Notif("~w~Entrez la ~b~quantité")
				inputquantiteitem = 1
				CloseCreatorinvmenu()
			elseif IsControlJustPressed(1,73)then
				Notif("Vous avez refusé l'item ~g~"..itemNameAskGive.."~w~ de la part de ~b~"..sourceNameAskGive)
			end
		end
	end
end)
		
--[[Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)
		if IsControlPressed(1, 323) and IsPedInAnyVehicle(GetPlayerPed(-1), true) == false then --Start holding X
			TaskHandsUp(GetPlayerPed(-1), 1000, GetPlayerPed(-1), -1, true) -- Perform animation.
		end
	end
end)--]]

function GetPlayers()
	local players = {}

	for i = 0, 31 do
		if NetworkIsPlayerActive(i) then
			table.insert(players, i)
		end
	end

	return players
end

function GetClosestPlayer()
	local players = GetPlayers()
	local closestDistance = -1
	local closestPlayer = -1
	local ply = GetPlayerPed(-1)
	local plyCoords = GetEntityCoords(ply, 0)
	
	for index,value in ipairs(players) do
		local target = GetPlayerPed(value)
		if(target ~= ply) then
			local targetCoords = GetEntityCoords(GetPlayerPed(value), 0)
			local distance = GetDistanceBetweenCoords(targetCoords["x"], targetCoords["y"], targetCoords["z"], plyCoords["x"], plyCoords["y"], plyCoords["z"], true)
			if(closestDistance == -1 or closestDistance > distance) then
				closestPlayer = value
				closestDistance = distance
			end
		end
	end
	
	return closestPlayer, closestDistance
end

Citizen.CreateThread(function()
	while true do
		Wait(1)
		t, distance = GetClosestPlayer()
		if(distance ~= -1 and distance < 3) then
			totarget = GetPlayerServerId(t)
		end
	end
end)
