require "resources/essentialmode/lib/MySQL"

MySQL:open(database.host, database.name, database.username, database.password)

-- Récupérer l'inventaire du joueur
RegisterServerEvent('MyInv')
AddEventHandler('MyInv',
  function()
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
			local playerName = GetPlayerName(source)
			local executed_query = MySQL:executeQuery("SELECT item_id, quantity FROM user_inventory WHERE user_id = '@identifier'", {['@identifier'] = user.identifier}) -- ON RECUPERE TOUS LES ITEMS DE L'UTILISATEUR --
			local result = MySQL:getResults(executed_query, {'item_id', 'quantity'}, "identifier")
			
			if (result ~= nil) then
				local executed_query2 = MySQL:executeQuery("SELECT * FROM items") -- ON RECUPERE TOUS LES NOM DES ITEMS EN FONCTION DE L'ID --
				local result1 = MySQL:getResults(executed_query2, {'name_singulier', 'name_pluriel', 'item_price_name', 'function_use_item'})
				TriggerClientEvent('MyInvClient', source, result, result1, playerName) -- MESSAGE --
			end
		end
    )
  end
)

-- Supprimer un item de l'inventaire
RegisterServerEvent('InvDelete')
AddEventHandler('InvDelete',
  function(itemId,nom)
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
		local executed_query2 = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@item' AND user_id ='@identifier'", {['@item'] = itemId, ['@identifier'] = user.identifier}) -- ON RECUPERE L'ID DE L'ITEM --
		local result2 = MySQL:getResults(executed_query2, {'quantity'})
		
		count = tonumber(result2[1].quantity)
		
		if(result2[1] ~= nil) then
			if(itemId ~= nil) then
				if(count > 1) then
					MySQL:executeQuery("UPDATE user_inventory SET `quantity`= @value WHERE user_id = '@identifier' AND item_id = '@item'", {['@identifier'] = user.identifier, ['@item'] = itemId, ['@value'] = count - 1}) -- ON MET A JOUR (-1) L'ITEM --
				else
					MySQL:executeQuery("DELETE FROM user_inventory WHERE user_id = '@identifier' AND item_id = '@item'", {['@identifier'] = user.identifier, ['@item'] = itemId}) -- ON SUPPRIME L'ITEM  --
					end
				end
				TriggerClientEvent('Deletesource', source, nom) -- Message d'information (supression item) --
			end
		end
    )
  end
)

-- Donner un item de l'inventaire (DEMANDE) [1/2]
RegisterServerEvent('inv:askGetItem')
AddEventHandler('inv:askGetItem',
  function(target,itemId,nameItem)
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
		local executed_query = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = user.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local result = MySQL:getResults(executed_query, {'quantity'})	

		if(result[1] ~= nil) then
			count = tonumber(result2[1].quantity)		
		  
			if(count ~= 0) then
				TriggerClientEvent('inv:askItemMessage', target, itemId, nameItem, getPlayerName(source)) -- Message d'information (demande pour l'obtention de l'item) --	
			else
				MySQL:executeQuery("DELETE FROM user_inventory WHERE user_id = '@identifier' AND item_id = '@item'", {['@identifier'] = user.identifier, ['@item'] = result[1].id}) -- ON SUPPRIME L'ITEM  --
				end
			end
		end
    )
  end
)

-- Donner un item de l'inventaire (ACCEPTER) [2/2]
RegisterServerEvent('inv:GetItem')
AddEventHandler('inv:GetItem',
  function(target,itemId, quantity, nameItem)
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
		local executed_query = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = user.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local result = MySQL:getResults(executed_query, {'quantity'})	

		if(result[1] ~= nil) then
			count = tonumber(result2[1].quantity)		
		  
			if(count > 1) then
				MySQL:executeQuery("UPDATE user_inventory SET `quantity`= @value WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = user.identifier, ['@value'] = count - quantity}) -- ON MET A JOUR LA QUANTITE DE L'ITEM CHEZ LA SOURCE --
				end
			end
			TriggerClientEvent('inv:setItemMessage', source, nameItem, getPlayerName(target)) -- Message d'information (On dit à la source qu'il a donné l'item à target) --	
		end
    )
  	TriggerEvent('es:getPlayerFromId', target, 
	function(cible)
	
		local executed_query = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = cible.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local result = MySQL:getResults(executed_query, {'quantity'})	
		
		if(result[1] ~= nil) then -- SI IL EST NULL LA TARGET N'A PAS ENCORE L'ITEM SUR LUI ;)
			MySQL:executeQuery("UPDATE user_inventory SET `quantity`= @value WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = cible.identifier, ['@value'] = count + quantity}) -- ON MET A JOUR LA QUANTITE DE L'ITEM DE LA TARGET --
		else
			MySQL:executeQuery("INSERT INTO user_inventory (user_id, item_id, quantity) VALUES ('@userId', '@itemId', '@quantity')", { ['@user_id'] = cible.identifier, ['@item_id'] = itemId, ['@quantity'] = quantity }) -- ON INSERT L'ITEM DANS LA BDD POUR LA TARGET --
			end
		end
		
		TriggerClientEvent('inv:receiveItemMessage', target, nameItem, getPlayerName(source)) -- Message d'information (On dit à la target qu'il a réçu l'item de la source) --	
	)
	end  
)

-- Obtenir un item  dans l'inventaire
RegisterServerEvent('inv:addItem')
AddEventHandler('inv:addItem',
  function(itemId, quantity)
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
		local executed_query = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = user.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local result = MySQL:getResults(executed_query, {'quantity'})	
		
		if(result[1] ~= nil) then -- SI IL EST NULL LA SOURCE N'A PAS ENCORE L'ITEM SUR LUI ;)
			count = tonumber(result[1].quantity)
			if count ~= 0 then
				MySQL:executeQuery("UPDATE user_inventory SET `quantity`= @value WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = user.identifier, ['@value'] = count + quantity}) -- ON MET A JOUR LA QUANTITE DE L'ITEM DE LA SOURCE --
			else
				MySQL:executeQuery("INSERT INTO user_inventory (user_id, item_id, quantity) VALUES ('@userId', '@itemId', '@quantity')", { ['@userId'] = user.identifier, ['@itemId'] = itemId, ['@quantity'] = quantity }) -- ON INSERT L'ITEM DANS LA BDD POUR LA SOURCE --
			end
		else
			MySQL:executeQuery("INSERT INTO user_inventory (user_id, item_id, quantity) VALUES ('@userId', '@itemId', '@quantity')", { ['@userId'] = user.identifier, ['@itemId'] = itemId, ['@quantity'] = quantity }) -- ON INSERT L'ITEM DANS LA BDD POUR LA SOURCE --
			end
		end
    )
  end
)

-- Supprimer un item  dans l'inventaire
RegisterServerEvent('inv:removeItem')
AddEventHandler('inv:removeItem',
  function(itemId, quantity)
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
		local executed_query = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = user.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local result = MySQL:getResults(executed_query, {'quantity'})	
		
		if(result[1] ~= nil) then -- SI IL EST NULL LA SOURCE N'A PAS ENCORE L'ITEM SUR LUI ;)
			count = tonumber(result[1].quantity)
			if count ~= 1 then
				MySQL:executeQuery("UPDATE user_inventory SET `quantity`= @value WHERE item_id = '@item' AND user_id ='@identifier'", {['@item'] = itemId, ['@identifier'] = user.identifier, ['@value'] = count - quantity}) -- ON MET A JOUR LA QUANTITE DE L'ITEM DE LA SOURCE --
			else
				MySQL:executeQuery("DELETE FROM user_inventory WHERE user_id = '@identifier' AND item_id = '@item'", {['@identifier'] = user.identifier, ['@item'] = itemId}) -- ON SUPPRIME L'ITEM  --
			end
		else
			MySQL:executeQuery("DELETE FROM user_inventory WHERE user_id = '@identifier' AND item_id = '@item'", {['@identifier'] = user.identifier, ['@item'] = itemId}) -- ON SUPPRIME L'ITEM  --
			end			
		end
    )
  end
)

-- Supprimer un item  dans l'inventaire
RegisterServerEvent('inv:removeSellItem')
AddEventHandler('inv:removeSellItem',
  function(itemId, quantity, price)
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
		local executed_query = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(itemId), ['@identifier'] = user.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local result = MySQL:getResults(executed_query, {'quantity'})	
		
		if(result[1] ~= nil) then -- SI IL EST NULL LA SOURCE N'A PAS ENCORE L'ITEM SUR LUI ;)
			user:addMoney(price)
			count = tonumber(result[1].quantity)
			if count ~= 1 then
				MySQL:executeQuery("UPDATE user_inventory SET `quantity`= @value WHERE item_id = '@item' AND user_id ='@identifier'", {['@item'] = itemId, ['@identifier'] = user.identifier, ['@value'] = count - quantity}) -- ON MET A JOUR LA QUANTITE DE L'ITEM DE LA SOURCE --
			else
				MySQL:executeQuery("DELETE FROM user_inventory WHERE user_id = '@identifier' AND item_id = '@item'", {['@identifier'] = user.identifier, ['@item'] = itemId}) -- ON SUPPRIME L'ITEM  --
			end
		else
			MySQL:executeQuery("DELETE FROM user_inventory WHERE user_id = '@identifier' AND item_id = '@item'", {['@identifier'] = user.identifier, ['@item'] = itemId}) -- ON SUPPRIME L'ITEM  --
			end			
		end
    )
  end
)

--# Ce code a été écrit par : MaSTeR #--
--# Je ne demande rien mais si vous voyez ceci-ci laissez mon nom, je vous en remercie #--