--[[Keys = {
    ["ESC"] = 322, ["F1"] = 288, ["F2"] = 289, ["F3"] = 170, ["F5"] = 166, ["F6"] = 167, ["F7"] = 168, ["F8"] = 169, ["F9"] = 56, ["F10"] = 57, 
    ["~"] = 243, ["1"] = 157, ["2"] = 158, ["3"] = 160, ["4"] = 164, ["5"] = 165, ["6"] = 159, ["7"] = 161, ["8"] = 162, ["9"] = 163, ["-"] = 84, ["="] = 83, ["BACKSPACE"] = 177, 
    ["TAB"] = 37, ["Q"] = 44, ["W"] = 32, 38 = 38, ["R"] = 45, ["T"] = 245, ["Y"] = 246, ["U"] = 303, ["P"] = 199, ["["] = 39, ["]"] = 40, ["ENTER"] = 18,
    ["CAPS"] = 137, ["A"] = 34, ["S"] = 8, ["D"] = 9, ["F"] = 23, ["G"] = 47, ["H"] = 74, ["K"] = 311, ["L"] = 182,
    ["LEFTSHIFT"] = 21, ["Z"] = 20, ["X"] = 73, ["C"] = 26, ["V"] = 0, ["B"] = 29, ["N"] = 249, ["M"] = 244, [","] = 82, ["."] = 81,
    ["LEFTCTRL"] = 36, ["LEFTALT"] = 19, ["SPACE"] = 22, ["RIGHTCTRL"] = 70, 
    ["HOME"] = 213, ["PAGEUP"] = 10, ["PAGEDOWN"] = 11, ["DELETE"] = 178,
    ["LEFT"] = 174, ["RIGHT"] = 175, ["TOP"] = 27, ["DOWN"] = 173,
    ["NENTER"] = 201, ["N4"] = 108, ["N5"] = 60, ["N6"] = 107, ["N+"] = 96, ["N-"] = 97, ["N7"] = 117, ["N8"] = 61, ["N9"] = 118
}]]--

local blipsClient
local blipsClientMission
local blipsJob
local CanDraw = false
local CanDrawMarker = false
local enService = false
local enZone = false
local enAction = false
local fakecar = {model = '', car = nil}
local get = false
local Pos = { }
local Item = { }
local poleEmploi = { x=-266.94, y=-960.744, z=30.0231, r=236, g=240, b=241 }

local polemenu = {
	opened = false,
	title = "Pole Emploi",
	currentmenu = "main",
	lastmenu = nil,
	currentpos = nil,
	selectedbutton = 0,
	marker = { r = 0, g = 155, b = 255, a = 200, type = 1 },
	menu = {
		x = 0.88,
		y = 0.32,
		width = 0.2,
		height = 0.04,
		buttons = 10,
		from = 1,
		to = 10,
		scale = 0.4,
		font = 0,
		["main"] = { 
			title = "CATEGORIES", 
			name = "main",
			buttons = { 			
			}
		},
		["metiers"] = { 
			title = "METIERS",
			name = "metiers",
			buttons = {
			}
		},	
	}
}

function drawTxt(text,font,centre,x,y,scale,r,g,b,a)
	SetTextFont(font)
	SetTextProportional(0)
	SetTextScale(scale, scale)
	SetTextColour(r, g, b, a)
	SetTextDropShadow(0, 0, 0, 0,255)
	SetTextEdge(1, 0, 0, 0, 255)
	SetTextDropShadow()
	SetTextOutline()
	SetTextCentre(centre)
	SetTextEntry("STRING")
	AddTextComponentString(text)
	DrawText(x , y)	
end

local function LocalPed()
return GetPlayerPed(-1)
end

inmenupole = 0

function OpenCreatorpolemenu()		
	polemenu.currentmenu = "main"
	polemenu.opened = true
	polemenu.selectedbutton = 0
end
function CloseCreatorpolemenu()
	Citizen.CreateThread(function()
		polemenu.opened = false
		polemenu.menu.from = 1
		polemenu.menu.to = 10
		inmenupole = 0
	end)
	Citizen.CreateThread(function()
	end)
end

--Menu pomenu

function drawMenuButton(button,x,y,selected)
	local menu = polemenu.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(menu.scale, menu.scale)
	if selected then
		SetTextColour(0, 0, 0, 255)
	else
		SetTextColour(255, 255, 255, 255)
	end
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(button.name)
	if selected then
		DrawRect(x,y,menu.width,menu.height,255,255,255,255)
	else
		DrawRect(x,y,menu.width,menu.height,0,0,0,150)
	end
	DrawText(x - menu.width/2 + 0.005, y - menu.height/2 + 0.0028)	
end

function drawMenuInfo(text)
	local menu = polemenu.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(0.45, 0.45)
	SetTextColour(255, 255, 255, 255)
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(text)
	DrawRect(0.675, 0.95,0.65,0.050,0,0,0,150)
	DrawText(0.365, 0.934)	
end

function MyIdentClient(text)
	ClearPrints()
	SetTextEntry("STRING")
	AddTextComponentString(text)
	DrawSubtitleTimed(4500, 1)
	SetTextScale(0.35, 0.35)
	SetTextColour( 255, 255, 255, 255)
	SetTextOutline()	
	DrawRect(0.91,0.40,0.175,0.50,0,0,0,150)			
	DrawText( 0.825, 0.25 )
end

function drawMenuRight(txt,x,y,selected)
	local menu = polemenu.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(menu.scale, menu.scale)
	SetTextRightJustify(1)
	if selected then
		SetTextColour(0, 0, 0, 255)
	else
		SetTextColour(255, 255, 255, 255)
	end
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(txt)
	DrawText(x + menu.width/2 - 0.03, y - menu.height/2 + 0.0028)	
end

function drawMenuTitlePolicem(txt,x,y)
local menu = polemenu.menu
	SetTextFont(2)
	SetTextProportional(0)
	SetTextScale(0.5, 0.5)
	SetTextColour(255, 255, 255, 255)
	SetTextEntry("STRING")
	AddTextComponentString(txt)
	DrawRect(x,y,menu.width,menu.height, 44, 62, 80, 150)
	DrawText(x - menu.width/2 + 0.005, y - menu.height/2 + 0.0028)
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function Notif(text)
	SetNotificationTextEntry("STRING")
	AddTextComponentString(text)
	DrawNotification(false, false)
end

function NotifTopLeft(text, state)
	SetTextComponentFormat("STRING")
	AddTextComponentString(text)
	DisplayHelpTextFromStringLabel(0, state, 0, -1)
end

function NotifBottom(text, time)
	ClearPrints()
	SetTextEntry_2("STRING")
	AddTextComponentString(text)
	DrawSubtitleTimed(time, 1)
end


local backlock = false

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)
		if GetDistanceBetweenCoords(poleEmploi.x,poleEmploi.y,poleEmploi.z,GetEntityCoords(LocalPed())) > 5 then
			DrawMarker(1, poleEmploi.x,poleEmploi.y,poleEmploi.z, 0, 0, 0, 0, 0, 0, 5.001, 5.0001, 0.9001, poleEmploi.r, poleEmploi.g, poleEmploi.b, 200, 0, 0, 0, 0)
		else
			if not polemenu.opened then
				NotifTopLeft("[~or~Pole Emploi~s~] : Appuyez sur ~INPUT_PICKUP~ ~s~pour ~g~ouvrir ~s~le menu")	
			else
				NotifTopLeft("[~or~Pole Emploi~s~] : Appuyez sur ~INPUT_PICKUP~ ~s~pour ~r~fermer ~s~le menu")	
			end
			
			if IsControlJustPressed(1, 38) then
				if IsPedInAnyVehicle(LocalPed(), true) == false then
					if polemenu.opened then
						CloseCreatorpolemenu()
						inmenupole = 0
					else
						TriggerServerEvent('job:getChomage')
					end
				else
					Notif("~r~Vous ne pouvez pas ouvrir le menu dans un véhicule !")
				end		
			end
		end
		if polemenu.opened then
			local ped = LocalPed()
			local menu = polemenu.menu[polemenu.currentmenu]
			drawTxt(polemenu.title,1,1,polemenu.menu.x,polemenu.menu.y,1.0, 255,255,255,255)
			drawMenuTitlePolicem(menu.title, polemenu.menu.x,polemenu.menu.y + 0.08)
			drawTxt(polemenu.selectedbutton.."/"..tablelength(menu.buttons),0,0,polemenu.menu.x + polemenu.menu.width/2 - 0.0385,polemenu.menu.y + 0.067,0.4, 255,255,255,255)
			local y = polemenu.menu.y + 0.12
			buttoncount = tablelength(menu.buttons)
			local selected = false
			
			for i,button in pairs(menu.buttons) do
				if i >= polemenu.menu.from and i <= polemenu.menu.to then
					
					if i == polemenu.selectedbutton then
						selected = true
					else
						selected = false
					end
					drawMenuButton(button,polemenu.menu.x,y,selected)
					y = y + 0.04
					if selected and IsControlJustPressed(1,201) then
						ButtonSelectedpolemenu(button)
					end
				end
			end	
		end
		if polemenu.opened then
			if IsControlJustPressed(1,202) then
				Backpolemenu()
			end
			if IsControlJustReleased(1,202) then
				backlock = false
			end
			if IsControlJustPressed(1,188) then
				if polemenu.selectedbutton > 1 then
					polemenu.selectedbutton = polemenu.selectedbutton -1
					if buttoncount > 10 and polemenu.selectedbutton < polemenu.menu.from then
						polemenu.menu.from = polemenu.menu.from -1
						polemenu.menu.to = polemenu.menu.to - 1
					end
				end
			end
			if IsControlJustPressed(1,187)then
				if polemenu.selectedbutton < buttoncount then
					polemenu.selectedbutton = polemenu.selectedbutton +1
					if buttoncount > 10 and polemenu.selectedbutton > polemenu.menu.to then
						polemenu.menu.to = polemenu.menu.to + 1
						polemenu.menu.from = polemenu.menu.from + 1
					end
				end	
			end
		end
	end
end)

		
function ButtonSelectedpolemenu(button)
	local ped = GetPlayerPed(-1)
	local this = polemenu.currentmenu
	local btn = button.name
	callx, cally, callz = table.unpack(GetEntityCoords(GetPlayerPed(-1) , true))
	if this == "main" then
		if btn == "Metiers (sans formation)" then
			TriggerServerEvent('job:getListJob')
		elseif btn == "Metiers (avec formation)" then
			Notif("Bientôt disponible !")
		elseif btn == "Démissionner" then
			TriggerServerEvent('job:newJob', 1)
			Notif("Vous êtes au ~r~Chômage")
			CloseCreatorpolemenu()
			CanDraw = false
			enService = false
			RemoveAllBlips()
			TriggerServerEvent('skin:loadSkinAndPosition')
			CanDrawMarker = false		
		end
	elseif this == "metiers" then
		if string.match(button.name, "SOON") then
			Notif("BIENTOT DISPO TDB")
		else
		TriggerServerEvent('job:newJob', button.id)
		Notif("Nouveau métier : ~g~"..button.name)
		TriggerServerEvent('job:getPos', button.id)
		CloseCreatorpolemenu()
		end
	end	
end

function Openmenupolemenu(menu)
	polemenu.lastmenu = polemenu.currentmenu
	if menu == "metiers" then
		polemenu.lastmenu = "main"
	end
	polemenu.menu.from = 1
	polemenu.menu.to = 10
	polemenu.selectedbutton = 0
	polemenu.currentmenu = menu	
end


function Backpolemenu()
	if backlock then
		return
	end
	backlock = true
	if polemenu.currentmenu == "main" then
		CloseCreatorpolemenu()
		inmenupole = 0
	else
		Openmenupolemenu(polemenu.lastmenu)
	end
end

RegisterNetEvent('job:setChomage')
AddEventHandler('job:setChomage', function(jobId)
    
	polemenu.menu["main"].buttons = {}
	
	if jobId == 1 then
		table.insert(polemenu.menu["main"].buttons, {name = "Metiers (sans formation)", description = ""})
		table.insert(polemenu.menu["main"].buttons, {name = "Metiers (avec formation)", description = ""})
	else
		table.insert(polemenu.menu["main"].buttons, {name = "Démissionner", description = ""})
	end
	
	OpenCreatorpolemenu()
	freezetargetCiv = totarget
	inmenupole = 1
	
end)

RegisterNetEvent('job:setJobList')
AddEventHandler('job:setJobList', function(tablerep)
    local a = tablerep
	
	polemenu.menu["metiers"].buttons = {}

	local i = 2
	while a[i] and i <= 10 do
		
	jobName = a[i]['job_name']
	jobId = a[i]['job_id']
    table.insert(polemenu.menu["metiers"].buttons, {name = jobName, description = "", id = jobId})

	i = i + 1
	end
	Openmenupolemenu('metiers')
	
end)

RegisterNetEvent('job:setEntreprisePos')
AddEventHandler('job:setEntreprisePos', function(X,Y,Z,name)	

	for k, existingBlip in pairs(blips) do
		if existingBlip ~= nil then
			RemoveBlip(existingBlip)
		end
    end	

	table.insert(blips, {title=name, colour=0, id=350, x=X, y=Y, z=Z})
	
	for _, info in pairs(blips) do
	  info.blip = AddBlipForCoord(info.x, info.y, info.z)
	  SetBlipSprite(info.blip, info.id)
	  SetBlipDisplay(info.blip, 4)
	  SetBlipScale(info.blip, 0.9)
	  SetBlipColour(info.blip, info.colour)
	  SetBlipAsShortRange(info.blip, true)
	  BeginTextCommandSetBlipName("STRING")
	  AddTextComponentString("Entreprise : "..info.title)
	  EndTextCommandSetBlipName(info.blip)
	end	
end)

RegisterNetEvent('job:drawBlips')
AddEventHandler('job:drawBlips', function (blips) 	
	for _, item in pairs(blips) do
		item.blip = AddBlipForCoord(item.x, item.y, item.z)
		SetBlipSprite(item.blip, item.id)
		SetBlipAsShortRange(item.blip, true)
		BeginTextCommandSetBlipName("STRING")
		AddTextComponentString("Entreprise : "..item.title)
		EndTextCommandSetBlipName(item.blip)		
	end
	
	if blipsClient ~= nil then
		for _, item in pairs(blipsClient) do
			RemoveBlip(item.blip)
		end
	end
	
	blipsClient = blips	
end)

RegisterNetEvent('job:drawBlipsMission')
AddEventHandler('job:drawBlipsMission', function (blipsMission) 	
	for _, item in pairs(blipsMission) do
		item.blip = AddBlipForCoord(item.x, item.y, item.z)
		SetBlipSprite(item.blip, 1)
		SetBlipAsShortRange(item.blip, true)
		BeginTextCommandSetBlipName("STRING")
		AddTextComponentString("Destination")
		EndTextCommandSetBlipName(item.blip)
        SetBlipColour(item.blip, 44, 62, 80, 150)
        SetBlipAsMissionCreatorBlip(item.blip,true)
        SetBlipRoute(item.blip, true)		
	end
	
	if blipsClientMission ~= nil then
		for _, item in pairs(blipsClientMission) do
			RemoveBlip(item.blip)
		end
	end
	
	blipsClientMission = blipsMission
	
	Citizen.CreateThread(function()
		while true do
			Wait(0)
			for _, item in pairs(blipsClientMission) do				
				if GetDistanceBetweenCoords(item.x,item.y,item.z,GetEntityCoords(LocalPed())) < 20 then
					SetEntityAsNoLongerNeeded(item.blip)
					SetBlipAsMissionCreatorBlip(item.blip,false)
					Citizen.InvokeNative(0x86A652570E5F25DD, Citizen.PointerValueIntInitialized(item.blip))
				end
			end
		end
	end)	
end)

RegisterNetEvent('job:drawMarkerEntreprise')
AddEventHandler('job:drawMarkerEntreprise', function(blipsMarker)	
	Citizen.CreateThread(function()
		CanDraw = true
		while CanDraw == true do
			Wait(0)				
			if GetDistanceBetweenCoords(blipsMarker[1].x,blipsMarker[1].y,blipsMarker[1].z,GetEntityCoords(LocalPed())) > 3 then
				DrawMarker(1, blipsMarker[1].x, blipsMarker[1].y, blipsMarker[1].z-1, 0, 0, 0, 0, 0, 0, 2.001, 2.0001, 0.5001, 231, 76, 60, 200, 0, 0, 0, 0)
			else
				if IsPedInAnyVehicle(LocalPed(), true) == false then
					if enService == false then
						NotifTopLeft("Appuyez sur ~INPUT_PICKUP~ pour ~b~mettre ~s~votre tenu de ~g~"..string.lower(blipsMarker[1].title))
						if IsControlJustPressed(1, 38) then
							GetServiceJob(blipsMarker[1].title, true)
						end				
					else
						NotifTopLeft("Appuyez sur ~INPUT_PICKUP~ pour ~r~retirer ~s~votre tenu de ~g~"..string.lower(blipsMarker[1].title))
						if IsControlJustPressed(1, 38) then
							GetServiceJob(blipsMarker[1].title, false)
						end						
					end
				end
			end
		end
	end)	
end)

function GetServiceJob(name, bool)
enService = bool
	if bool then
		Notif("~b~Prise ~s~de service : ~g~"..string.lower(name))
		TriggerEvent("es_freeroam:notify", "CHAR_PLANESITE", 1, "Entreprise", false, "Les coordonnées ~b~GPS ~w~des points de production vous ont été envoyés.")
		TriggerServerEvent('job:loadSkinByJob', name)
		TriggerServerEvent('job:setBlipsForJob', name)
		CanDrawMarker = true
	else
		Notif("~r~Arrêt ~s~de service : ~g~"..string.lower(name))	
		RemoveAllBlips()
		TriggerServerEvent('skin:loadSkinAndPosition')
		CanDrawMarker = false
	end
end

RegisterNetEvent('job:setSkinByJob')
AddEventHandler('job:setSkinByJob', function (skinList) 	
	for _, item in pairs(skinList) do
		SetPedComponentVariation(GetPlayerPed(-1), item.componentid, item.drawableid, item.textureid, item.paletteid)	
	end
end)


RegisterNetEvent('job:updateJobHud')
AddEventHandler('job:updateJobHud', function(nameJob)
	local id = PlayerId()
	local playerName = GetPlayerName(id)
	
	SendNUIMessage({
		updateJob = true,
		job = nameJob,
		player = playerName
	})
end)

RegisterNetEvent('job:drawBlipsForJob')
AddEventHandler('job:drawBlipsForJob', function (mytable) 	
	for _, item in pairs(mytable) do
		item.blip = AddBlipForCoord(item.x, item.y, item.z)
		SetBlipSprite(item.blip, item.id)
		SetBlipAsShortRange(item.blip, true)
		BeginTextCommandSetBlipName("STRING")
		AddTextComponentString(item.name)
		EndTextCommandSetBlipName(item.blip)		
	end
	
	if blipsJob ~= nil then
		for _, item in pairs(blipsJob) do
			RemoveBlip(item.blip)
		end
	end
	
	blipsJob = mytable		
end)

function RemoveAllBlips()
	if blipsClient ~= nil then
		for _, simple in pairs(blipsClient) do
			RemoveBlip(simple.blip)
		end
	end
	
	if blipsClientMission ~= nil then
		for _, mission in pairs(blipsClientMission) do
			RemoveBlip(mission.blip)
		end
	end
	
	if blipsJob ~= nil then
		for _, job in pairs(blipsJob) do
			RemoveBlip(job.blip)
		end
	end	
end

RegisterNetEvent('job:ResultOfQuantityItem')
AddEventHandler('job:ResultOfQuantityItem', function(quantityRecolte, quantityTraitement)	
	Notif(quantityRecolte)
	Notif(quantityTraitement)
	t = { recolt=quantityRecolte, traitement=quantityTraitement }
	Item = t
end)

RegisterNetEvent('job:drawMarkerProduction')
AddEventHandler('job:drawMarkerProduction', function(blipsMarker)	
	Citizen.CreateThread(function()
		while CanDrawMarker == true do
			Wait(0)
			for _, marker in pairs(blipsMarker) do
				if GetDistanceBetweenCoords(marker.x,marker.y,marker.z,GetEntityCoords(LocalPed())) > 5 then
					DrawMarker(1, marker.x, marker.y, marker.z-1, 0, 0, 0, 0, 0, 0, 5.001, 5.0001, 0.9001, marker.r, marker.g, marker.b, 200, 0, 0, 0, 0)
				else
					if IsPedInAnyVehicle(LocalPed(), true) == false then
						if enService == true then
							if marker.id ~= 17 then
								if enAction == false then								
									NotifTopLeft("[~or~"..marker.title.."~s~] : Appuyez sur ~INPUT_PICKUP~ ~s~pour ~g~démarrer")									
									if IsControlJustPressed(1, 38) then
										GetPos(marker.item_r, marker.item_t)
										enAction = true
										Citizen.Wait(100)										
										if	marker.id == 18 then -- Récolte											
											Citizen.CreateThread(function()											
												while enAction and enZone do
													Wait(0)
													local ply = GetPlayerPed(-1)
													local plyCoords = GetEntityCoords(ply, 0)													
													if GetDistanceBetweenCoords(Pos.x,Pos.y,Pos.z,plyCoords["x"], plyCoords["y"], plyCoords["z"], true) < 10 then														
														if Item.recolt <= 30 then
															NotifBottom(marker.title.." en cours de ~or~"..string.lower(marker.item_r_name), 5000)
															Citizen.Wait(5000)
															NotifBottom("Vous avez obtenu ~g~1 ~or~"..string.lower(marker.item_r_name), 1000)
															TriggerServerEvent('inv:addItem', marker.item_r, 1)
															Item.recolt = Item.recolt + 1	
															Citizen.Wait(1000)
														else
															NotifBottom("Récolte ~g~terminée~s~, vous avez trop de ~or~"..item_r_name, 3000)
															enAction = false
															enZone = false
														end
													else												
														NotifBottom("Vous avez ~r~quitté ~s~la zone de "..string.lower(marker.title), 4000)
														enAction = false
														enZone = false
													end															
												end
											end)
										elseif marker.id == 19 then -- Traitement
											Citizen.CreateThread(function()											
												while enAction and enZone do
													Wait(0)
													local ply = GetPlayerPed(-1)
													local plyCoords = GetEntityCoords(ply, 0)													
													if GetDistanceBetweenCoords(Pos.x,Pos.y,Pos.z,plyCoords["x"], plyCoords["y"], plyCoords["z"], true) < 10 then
														if Item.recolt >= 1 and Item.traitement <= 60 then
															NotifBottom(marker.title.." en cours de ~or~"..string.lower(marker.item_r_name), 5000)
															Citizen.Wait(5000)
															NotifBottom("Vous avez obtenu ~g~1 ~or~"..string.lower(marker.item_t_name), 1000)
															TriggerServerEvent('inv:addItem', marker.item_t, 1)
															TriggerServerEvent('inv:removeItem', marker.item_r, 1)
															Item.recolt = Item.recolt - 1
															Item.traitement = Item.traitement + 1	
															Citizen.Wait(1000)
														else
															NotifBottom("Traitement terminé~s~, vous avez trop de ~or~"..item_t_name, 3000)
															enAction = false
															enZone = false
														end
													else												
														NotifBottom("Vous avez ~r~quitté ~s~la zone de "..string.lower(marker.title), 4000)
														enAction = false
														enZone = false
													end															
												end
											end)	
										elseif marker.id == 20 then	-- Revente
											Citizen.CreateThread(function()		
												while enAction and enZone do
													Wait(0)
													local ply = GetPlayerPed(-1)
													local plyCoords = GetEntityCoords(ply, 0)	
													if GetDistanceBetweenCoords(Pos.x,Pos.y,Pos.z,plyCoords["x"], plyCoords["y"], plyCoords["z"], true) < 10 then
														if Item.traitement >= 1 then
															NotifBottom(marker.title.." en cours de ~or~"..string.lower(marker.item_t_name), 5000)
															Citizen.Wait(5000)
															NotifBottom("Vous avez obtenu ~g~"..marker.price.."€", 1000)
															TriggerServerEvent('inv:removeSellItem', marker.item_t, 1, marker.price)
															Item.traitement = Item.traitement - 1	
															Citizen.Wait(1000)
														else
															NotifBottom("Revente ~g~terminée~s~, vous n'avez plus de ~or~"..marker.item_t_name, 3000)
															enAction = false
															enZone = false
														end
													else												
														NotifBottom("Vous avez ~r~quitté ~s~la zone de "..string.lower(marker.title), 4000)
														enAction = false
														enZone = false
													end														
												end
											end)
										end										
									end
								else
									NotifTopLeft("[~or~"..marker.title.."~s~] : Appuyez sur ~INPUT_PICKUP~ ~s~pour ~r~arrêter")		
									if IsControlJustPressed(1, 38) then
										enAction = false
										enZone = false
									end		
								end	
							else
								NotifTopLeft("[~or~"..marker.title.."~s~] : Appuyez sur ~INPUT_PICKUP~ ~s~pour ~g~obtenir ~s~votre vehicule")	
								if IsControlJustPressed(1, 38) then
									if DoesEntityExist(fakecar.car) then
										Citizen.InvokeNative(0xEA386986E786A54F, Citizen.PointerValueIntInitialized(fakecar.car))
									end			
									local ped = LocalPed()
									local plyCoords = GetEntityCoords(ped, 0)
									local hash = GetHashKey(marker.vehicle_name)
									RequestModel(hash)
									while not HasModelLoaded(hash) do
										Citizen.Wait(0)
									end
									local veh = CreateVehicle(hash,marker.x,marker.y,marker.z,90.02,true,false)
									SetVehicleNumberPlateText(veh, "HOPEV")
									SetVehicleMod(veh, 11, 2)
									SetVehicleMod(veh, 12, 2)
									SetVehicleMod(veh, 13, 2)
									SetVehicleEnginePowerMultiplier(veh, 20.0)
									fakecar = { model = marker.vehicle_name, car = veh}
								end			
							end
						end
					else
						if marker.id ~= 17 then
							NotifBottom("~r~Vous ne pouvez pas être dans un véhicule")
							if enAction then
								enAction = false
								enZone = false
								NotifBottom("Vous avez ~r~quitté ~s~la zone de "..string.lower(marker.title), 4000)
							end
						end						
					end							
				end
			end
		end
	end)	
end)

function GetPos(r, t)
	if enZone == false then
		enZone = true
		TriggerServerEvent('job:CheckItemQuantityToUser', r, t)
		local ply = GetPlayerPed(-1)
		local plyCoords = GetEntityCoords(ply, 0)
		
		t = { x=plyCoords["x"], y=plyCoords["y"], z=plyCoords["z"] }
		
		Pos = t
	end
end